<?php namespace EwCacheInvalidator;

use EwCacheInvalidator\PageDebug;
use EwCacheInvalidator\PageSettings;
use EwCacheInvalidator\EventHandler;

/**
 * Class Startup
 * @package EwCacheInvalidator
 */
class Startup {

    /**
     * Startup constructor.
     * @param $plugin_path
     */
    public function __construct($plugin_path) {

        // TODO: Package as composer plugin stuff.
        // TODO: Twig support.
        // TODO: Implement board queries fetcher as a plugin.

        // Register pages for menu.
        add_action('admin_menu', function() {

            $page_debug = new PageDebug();
            $page_settings = new PageSettings();

            add_menu_page(__('EW cache invalidator', 'ew-cache-invalidator'), 'EW Cache', 'manage_options', 'ew-cache-invalidator', '', 'dashicons-admin-settings');
            add_submenu_page( 'ew-cache-invalidator', __('Cache invalidation settings', 'ew-cache-invalidator'), __('Settings', 'ew-cache-invalidator'), 'manage_options', 'ew-cache-invalidator', array( $page_settings, 'renderAdminPage' ) );
            add_submenu_page( 'ew-cache-invalidator', __('Cache invalidation data', 'ew-cache-invalidator'), __('Debug data', 'ew-cache-invalidator'), 'manage_options', 'ew-cache-invalidator-debug', array($page_debug, 'renderAdminPage' ) );
        });

        $this->setupAjax();
        if(PageSettings::checkQueryEventsActive()) {
            $eventHandler = new EventHandler();
        }
    }

    /**
     * Setup ajax functions.
     */
    private function setupAjax() {

        add_action('wp_ajax_ew_cache_invalidator_reset_all_queries', function() {
            PageSettings::ajaxResetAllQueries();
        });
    }
}